//pdata_sample.cpp
#include <iostream>
using namespace std;

class Data
{
    int n;
    int* p;
public:
    Data(int d) : n(d), p(new int[d]){}
    ~Data(){ delete [] p; }
    Data(const Data&);            //Rs[RXgN^̐錾
    Data& operator=(const Data&); //Zq̐錾
    int get_size() const{ return n; }
    void set_data(int i, int x){ p[i] = x; }
    int get_data(int i) const{ return p[i]; }
};

//Rs[RXgN^̒`
Data::Data(const Data& a){
    n = a.get_size();
    p = new int[n];
    for(int i = 0; i < n; i++)
        p[i] = a.p[i];
}

//Zq̒`
Data& Data::operator=(const Data& a){
    if(&a == this)  //ȑ̏ꍇ
        return *this;
    delete [] p;
    n = a.get_size();
    p = new int[n];
    for(int i = 0; i < n; i++)
        p[i] = a.p[i];
    return *this;
}

int main()
{
    Data a(3);
    //a̔z̗vfɃf[^Zbg
    for(int i = 0; i < a.get_size(); i++)
        a.set_data(i, 100 * (i + 1));
    Data b = a;   //baRs[iRs[RXgN^Ă΂j
    cout << "bF";
    for(int i = 0; i < b.get_size(); i++)
        cout << b.get_data(i) << " ";
    cout << endl;
    Data c(5);
    c = a;        //caiZqĂ΂j
    cout << "cF";
    for(int i = 0; i < c.get_size(); i++)
        cout << c.get_data(i) << " ";
    cout << endl;
}
